/* Device.c generated by valac 0.43.4, the Vala compiler
 * generated from Device.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016-2018 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */
/* This is a read-only class, set the properties via PulseAudioManager.*/

#include <glib-object.h>
#include <gee.h>
#include <pulse/pulseaudio.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gobject/gvaluecollector.h>

#define SOUND_TYPE_DEVICE (sound_device_get_type ())
#define SOUND_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_DEVICE, SoundDevice))
#define SOUND_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_DEVICE, SoundDeviceClass))
#define SOUND_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_DEVICE))
#define SOUND_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_DEVICE))
#define SOUND_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_DEVICE, SoundDeviceClass))

typedef struct _SoundDevice SoundDevice;
typedef struct _SoundDeviceClass SoundDeviceClass;
typedef struct _SoundDevicePrivate SoundDevicePrivate;

#define SOUND_DEVICE_TYPE_PORT (sound_device_port_get_type ())
#define SOUND_DEVICE_PORT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_DEVICE_TYPE_PORT, SoundDevicePort))
#define SOUND_DEVICE_PORT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_DEVICE_TYPE_PORT, SoundDevicePortClass))
#define SOUND_DEVICE_IS_PORT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_DEVICE_TYPE_PORT))
#define SOUND_DEVICE_IS_PORT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_DEVICE_TYPE_PORT))
#define SOUND_DEVICE_PORT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_DEVICE_TYPE_PORT, SoundDevicePortClass))

typedef struct _SoundDevicePort SoundDevicePort;
typedef struct _SoundDevicePortClass SoundDevicePortClass;
enum  {
	SOUND_DEVICE_0_PROPERTY,
	SOUND_DEVICE_INPUT_PROPERTY,
	SOUND_DEVICE_INDEX_PROPERTY,
	SOUND_DEVICE_NAME_PROPERTY,
	SOUND_DEVICE_DISPLAY_NAME_PROPERTY,
	SOUND_DEVICE_FORM_FACTOR_PROPERTY,
	SOUND_DEVICE_IS_DEFAULT_PROPERTY,
	SOUND_DEVICE_IS_MUTED_PROPERTY,
	SOUND_DEVICE_VOLUME_PROPERTY,
	SOUND_DEVICE_BALANCE_PROPERTY,
	SOUND_DEVICE_PORTS_PROPERTY,
	SOUND_DEVICE_DEFAULT_PORT_PROPERTY,
	SOUND_DEVICE_NUM_PROPERTIES
};
static GParamSpec* sound_device_properties[SOUND_DEVICE_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _sound_device_port_unref0(var) ((var == NULL) ? NULL : (var = (sound_device_port_unref (var), NULL)))
typedef struct _SoundDevicePortPrivate SoundDevicePortPrivate;
typedef struct _SoundDeviceParamSpecPort SoundDeviceParamSpecPort;
enum  {
	SOUND_DEVICE_REMOVED_SIGNAL,
	SOUND_DEVICE_NUM_SIGNALS
};
static guint sound_device_signals[SOUND_DEVICE_NUM_SIGNALS] = {0};

struct _SoundDevice {
	GObject parent_instance;
	SoundDevicePrivate * priv;
	GeeLinkedList* volume_operations;
};

struct _SoundDeviceClass {
	GObjectClass parent_class;
};

struct _SoundDevicePrivate {
	gboolean _input;
	guint32 _index;
	gchar* _name;
	gchar* _display_name;
	gchar* _form_factor;
	gboolean _is_default;
	gboolean _is_muted;
	pa_cvolume _cvolume;
	gdouble _volume;
	gfloat _balance;
	pa_channel_map _channel_map;
	GeeArrayList* _ports;
	SoundDevicePort* _default_port;
};

struct _SoundDevicePort {
	GTypeInstance parent_instance;
	volatile int ref_count;
	SoundDevicePortPrivate * priv;
	gchar* name;
	gchar* description;
	guint32 priority;
};

struct _SoundDevicePortClass {
	GTypeClass parent_class;
	void (*finalize) (SoundDevicePort *self);
};

struct _SoundDeviceParamSpecPort {
	GParamSpec parent_instance;
};

static gint SoundDevice_private_offset;
static gpointer sound_device_parent_class = NULL;
static gpointer sound_device_port_parent_class = NULL;

GType sound_device_get_type (void) G_GNUC_CONST;
gpointer sound_device_port_ref (gpointer instance);
void sound_device_port_unref (gpointer instance);
GParamSpec* sound_device_param_spec_port (const gchar* name,
                                          const gchar* nick,
                                          const gchar* blurb,
                                          GType object_type,
                                          GParamFlags flags);
void sound_device_value_set_port (GValue* value,
                                  gpointer v_object);
void sound_device_value_take_port (GValue* value,
                                   gpointer v_object);
gpointer sound_device_value_get_port (const GValue* value);
GType sound_device_port_get_type (void) G_GNUC_CONST;
SoundDevice* sound_device_new (guint32 index);
SoundDevice* sound_device_construct (GType object_type,
                                     guint32 index);
gchar* sound_device_get_nice_form_factor (SoundDevice* self);
const gchar* sound_device_get_form_factor (SoundDevice* self);
gboolean sound_device_get_input (SoundDevice* self);
void sound_device_set_input (SoundDevice* self,
                             gboolean value);
guint32 sound_device_get_index (SoundDevice* self);
static void sound_device_set_index (SoundDevice* self,
                             guint32 value);
const gchar* sound_device_get_name (SoundDevice* self);
void sound_device_set_name (SoundDevice* self,
                            const gchar* value);
const gchar* sound_device_get_display_name (SoundDevice* self);
void sound_device_set_display_name (SoundDevice* self,
                                    const gchar* value);
void sound_device_set_form_factor (SoundDevice* self,
                                   const gchar* value);
gboolean sound_device_get_is_default (SoundDevice* self);
void sound_device_set_is_default (SoundDevice* self,
                                  gboolean value);
gboolean sound_device_get_is_muted (SoundDevice* self);
void sound_device_set_is_muted (SoundDevice* self,
                                gboolean value);
void sound_device_get_cvolume (SoundDevice* self,
                               pa_cvolume * result);
void sound_device_set_cvolume (SoundDevice* self,
                               pa_cvolume * value);
gdouble sound_device_get_volume (SoundDevice* self);
void sound_device_set_volume (SoundDevice* self,
                              gdouble value);
gfloat sound_device_get_balance (SoundDevice* self);
void sound_device_set_balance (SoundDevice* self,
                               gfloat value);
void sound_device_get_channel_map (SoundDevice* self,
                                   pa_channel_map * result);
void sound_device_set_channel_map (SoundDevice* self,
                                   pa_channel_map * value);
GeeArrayList* sound_device_get_ports (SoundDevice* self);
void sound_device_set_ports (SoundDevice* self,
                             GeeArrayList* value);
SoundDevicePort* sound_device_get_default_port (SoundDevice* self);
void sound_device_set_default_port (SoundDevice* self,
                                    SoundDevicePort* value);
static GObject * sound_device_constructor (GType type,
                                    guint n_construct_properties,
                                    GObjectConstructParam * construct_properties);
SoundDevicePort* sound_device_port_new (void);
SoundDevicePort* sound_device_port_construct (GType object_type);
static void sound_device_port_finalize (SoundDevicePort * obj);
static void sound_device_finalize (GObject * obj);
static void _vala_sound_device_get_property (GObject * object,
                                      guint property_id,
                                      GValue * value,
                                      GParamSpec * pspec);
static void _vala_sound_device_set_property (GObject * object,
                                      guint property_id,
                                      const GValue * value,
                                      GParamSpec * pspec);

static inline gpointer
sound_device_get_instance_private (SoundDevice* self)
{
	return G_STRUCT_MEMBER_P (self, SoundDevice_private_offset);
}

SoundDevice*
sound_device_construct (GType object_type,
                        guint32 index)
{
	SoundDevice * self = NULL;
#line 49 "../src/Device.vala"
	self = (SoundDevice*) g_object_new (object_type, "index", index, NULL);
#line 48 "../src/Device.vala"
	return self;
#line 224 "Device.c"
}

SoundDevice*
sound_device_new (guint32 index)
{
#line 48 "../src/Device.vala"
	return sound_device_construct (SOUND_TYPE_DEVICE, index);
#line 232 "Device.c"
}

gchar*
sound_device_get_nice_form_factor (SoundDevice* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 58 "../src/Device.vala"
	static GQuark _tmp2_label0 = 0;
#line 58 "../src/Device.vala"
	static GQuark _tmp2_label1 = 0;
#line 58 "../src/Device.vala"
	static GQuark _tmp2_label2 = 0;
#line 58 "../src/Device.vala"
	static GQuark _tmp2_label3 = 0;
#line 58 "../src/Device.vala"
	static GQuark _tmp2_label4 = 0;
#line 58 "../src/Device.vala"
	static GQuark _tmp2_label5 = 0;
#line 58 "../src/Device.vala"
	static GQuark _tmp2_label6 = 0;
#line 58 "../src/Device.vala"
	static GQuark _tmp2_label7 = 0;
#line 58 "../src/Device.vala"
	static GQuark _tmp2_label8 = 0;
#line 58 "../src/Device.vala"
	static GQuark _tmp2_label9 = 0;
#line 58 "../src/Device.vala"
	static GQuark _tmp2_label10 = 0;
#line 58 "../src/Device.vala"
	static GQuark _tmp2_label11 = 0;
#line 58 "../src/Device.vala"
	static GQuark _tmp2_label12 = 0;
#line 57 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 58 "../src/Device.vala"
	_tmp0_ = self->priv->_form_factor;
#line 58 "../src/Device.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/Device.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 58 "../src/Device.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("internal")))) {
#line 58 "../src/Device.vala"
		switch (0) {
#line 280 "Device.c"
			default:
			{
				gchar* _tmp4_;
#line 60 "../src/Device.vala"
				_tmp4_ = g_strdup (_ ("Built-in"));
#line 60 "../src/Device.vala"
				result = _tmp4_;
#line 60 "../src/Device.vala"
				return result;
#line 290 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("speaker")))) {
#line 58 "../src/Device.vala"
		switch (0) {
#line 296 "Device.c"
			default:
			{
				gchar* _tmp5_;
#line 62 "../src/Device.vala"
				_tmp5_ = g_strdup (_ ("Speaker"));
#line 62 "../src/Device.vala"
				result = _tmp5_;
#line 62 "../src/Device.vala"
				return result;
#line 306 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("handset")))) {
#line 58 "../src/Device.vala"
		switch (0) {
#line 312 "Device.c"
			default:
			{
				gchar* _tmp6_;
#line 64 "../src/Device.vala"
				_tmp6_ = g_strdup (_ ("Handset"));
#line 64 "../src/Device.vala"
				result = _tmp6_;
#line 64 "../src/Device.vala"
				return result;
#line 322 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("tv")))) {
#line 58 "../src/Device.vala"
		switch (0) {
#line 328 "Device.c"
			default:
			{
				gchar* _tmp7_;
#line 66 "../src/Device.vala"
				_tmp7_ = g_strdup (_ ("TV"));
#line 66 "../src/Device.vala"
				result = _tmp7_;
#line 66 "../src/Device.vala"
				return result;
#line 338 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("webcam")))) {
#line 58 "../src/Device.vala"
		switch (0) {
#line 344 "Device.c"
			default:
			{
				gchar* _tmp8_;
#line 68 "../src/Device.vala"
				_tmp8_ = g_strdup (_ ("Webcam"));
#line 68 "../src/Device.vala"
				result = _tmp8_;
#line 68 "../src/Device.vala"
				return result;
#line 354 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("microphone")))) {
#line 58 "../src/Device.vala"
		switch (0) {
#line 360 "Device.c"
			default:
			{
				gchar* _tmp9_;
#line 70 "../src/Device.vala"
				_tmp9_ = g_strdup (_ ("Microphone"));
#line 70 "../src/Device.vala"
				result = _tmp9_;
#line 70 "../src/Device.vala"
				return result;
#line 370 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("headset")))) {
#line 58 "../src/Device.vala"
		switch (0) {
#line 376 "Device.c"
			default:
			{
				gchar* _tmp10_;
#line 72 "../src/Device.vala"
				_tmp10_ = g_strdup (_ ("Headset"));
#line 72 "../src/Device.vala"
				result = _tmp10_;
#line 72 "../src/Device.vala"
				return result;
#line 386 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("headphone")))) {
#line 58 "../src/Device.vala"
		switch (0) {
#line 392 "Device.c"
			default:
			{
				gchar* _tmp11_;
#line 74 "../src/Device.vala"
				_tmp11_ = g_strdup (_ ("Headphone"));
#line 74 "../src/Device.vala"
				result = _tmp11_;
#line 74 "../src/Device.vala"
				return result;
#line 402 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("hands-free")))) {
#line 58 "../src/Device.vala"
		switch (0) {
#line 408 "Device.c"
			default:
			{
				gchar* _tmp12_;
#line 76 "../src/Device.vala"
				_tmp12_ = g_strdup (_ ("Hands-Free"));
#line 76 "../src/Device.vala"
				result = _tmp12_;
#line 76 "../src/Device.vala"
				return result;
#line 418 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("car")))) {
#line 58 "../src/Device.vala"
		switch (0) {
#line 424 "Device.c"
			default:
			{
				gchar* _tmp13_;
#line 78 "../src/Device.vala"
				_tmp13_ = g_strdup (_ ("Car"));
#line 78 "../src/Device.vala"
				result = _tmp13_;
#line 78 "../src/Device.vala"
				return result;
#line 434 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("hifi")))) {
#line 58 "../src/Device.vala"
		switch (0) {
#line 440 "Device.c"
			default:
			{
				gchar* _tmp14_;
#line 80 "../src/Device.vala"
				_tmp14_ = g_strdup (_ ("HiFi"));
#line 80 "../src/Device.vala"
				result = _tmp14_;
#line 80 "../src/Device.vala"
				return result;
#line 450 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label11) ? _tmp2_label11 : (_tmp2_label11 = g_quark_from_static_string ("computer")))) {
#line 58 "../src/Device.vala"
		switch (0) {
#line 456 "Device.c"
			default:
			{
				gchar* _tmp15_;
#line 82 "../src/Device.vala"
				_tmp15_ = g_strdup (_ ("Computer"));
#line 82 "../src/Device.vala"
				result = _tmp15_;
#line 82 "../src/Device.vala"
				return result;
#line 466 "Device.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label12) ? _tmp2_label12 : (_tmp2_label12 = g_quark_from_static_string ("portable")))) {
#line 58 "../src/Device.vala"
		switch (0) {
#line 472 "Device.c"
			default:
			{
				gchar* _tmp16_;
#line 84 "../src/Device.vala"
				_tmp16_ = g_strdup (_ ("Portable"));
#line 84 "../src/Device.vala"
				result = _tmp16_;
#line 84 "../src/Device.vala"
				return result;
#line 482 "Device.c"
			}
		}
	} else {
#line 58 "../src/Device.vala"
		switch (0) {
#line 488 "Device.c"
			default:
			{
				const gchar* _tmp17_ = NULL;
				gboolean _tmp18_;
				gchar* _tmp19_;
#line 86 "../src/Device.vala"
				_tmp18_ = self->priv->_input;
#line 86 "../src/Device.vala"
				if (_tmp18_) {
#line 86 "../src/Device.vala"
					_tmp17_ = _ ("Input");
#line 500 "Device.c"
				} else {
#line 86 "../src/Device.vala"
					_tmp17_ = _ ("Output");
#line 504 "Device.c"
				}
#line 86 "../src/Device.vala"
				_tmp19_ = g_strdup (_tmp17_);
#line 86 "../src/Device.vala"
				result = _tmp19_;
#line 86 "../src/Device.vala"
				return result;
#line 512 "Device.c"
			}
		}
	}
}

gboolean
sound_device_get_input (SoundDevice* self)
{
	gboolean result;
#line 33 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "../src/Device.vala"
	result = self->priv->_input;
#line 33 "../src/Device.vala"
	return result;
#line 528 "Device.c"
}

void
sound_device_set_input (SoundDevice* self,
                        gboolean value)
{
#line 33 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Device.vala"
	if (sound_device_get_input (self) != value) {
#line 33 "../src/Device.vala"
		self->priv->_input = value;
#line 33 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_INPUT_PROPERTY]);
#line 543 "Device.c"
	}
}

guint32
sound_device_get_index (SoundDevice* self)
{
	guint32 result;
#line 34 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 34 "../src/Device.vala"
	result = self->priv->_index;
#line 34 "../src/Device.vala"
	return result;
#line 557 "Device.c"
}

static void
sound_device_set_index (SoundDevice* self,
                        guint32 value)
{
#line 34 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Device.vala"
	if (sound_device_get_index (self) != value) {
#line 34 "../src/Device.vala"
		self->priv->_index = value;
#line 34 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_INDEX_PROPERTY]);
#line 572 "Device.c"
	}
}

const gchar*
sound_device_get_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 35 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 35 "../src/Device.vala"
	_tmp0_ = self->priv->_name;
#line 35 "../src/Device.vala"
	result = _tmp0_;
#line 35 "../src/Device.vala"
	return result;
#line 589 "Device.c"
}

void
sound_device_set_name (SoundDevice* self,
                       const gchar* value)
{
#line 35 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_name (self)) != 0) {
#line 600 "Device.c"
		gchar* _tmp0_;
#line 35 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 35 "../src/Device.vala"
		_g_free0 (self->priv->_name);
#line 35 "../src/Device.vala"
		self->priv->_name = _tmp0_;
#line 35 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_NAME_PROPERTY]);
#line 610 "Device.c"
	}
}

const gchar*
sound_device_get_display_name (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/Device.vala"
	_tmp0_ = self->priv->_display_name;
#line 36 "../src/Device.vala"
	result = _tmp0_;
#line 36 "../src/Device.vala"
	return result;
#line 627 "Device.c"
}

void
sound_device_set_display_name (SoundDevice* self,
                               const gchar* value)
{
#line 36 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_display_name (self)) != 0) {
#line 638 "Device.c"
		gchar* _tmp0_;
#line 36 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 36 "../src/Device.vala"
		_g_free0 (self->priv->_display_name);
#line 36 "../src/Device.vala"
		self->priv->_display_name = _tmp0_;
#line 36 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_DISPLAY_NAME_PROPERTY]);
#line 648 "Device.c"
	}
}

const gchar*
sound_device_get_form_factor (SoundDevice* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 37 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/Device.vala"
	_tmp0_ = self->priv->_form_factor;
#line 37 "../src/Device.vala"
	result = _tmp0_;
#line 37 "../src/Device.vala"
	return result;
#line 665 "Device.c"
}

void
sound_device_set_form_factor (SoundDevice* self,
                              const gchar* value)
{
#line 37 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/Device.vala"
	if (g_strcmp0 (value, sound_device_get_form_factor (self)) != 0) {
#line 676 "Device.c"
		gchar* _tmp0_;
#line 37 "../src/Device.vala"
		_tmp0_ = g_strdup (value);
#line 37 "../src/Device.vala"
		_g_free0 (self->priv->_form_factor);
#line 37 "../src/Device.vala"
		self->priv->_form_factor = _tmp0_;
#line 37 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_FORM_FACTOR_PROPERTY]);
#line 686 "Device.c"
	}
}

gboolean
sound_device_get_is_default (SoundDevice* self)
{
	gboolean result;
#line 38 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "../src/Device.vala"
	result = self->priv->_is_default;
#line 38 "../src/Device.vala"
	return result;
#line 700 "Device.c"
}

void
sound_device_set_is_default (SoundDevice* self,
                             gboolean value)
{
#line 38 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/Device.vala"
	if (sound_device_get_is_default (self) != value) {
#line 38 "../src/Device.vala"
		self->priv->_is_default = value;
#line 38 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_IS_DEFAULT_PROPERTY]);
#line 715 "Device.c"
	}
}

gboolean
sound_device_get_is_muted (SoundDevice* self)
{
	gboolean result;
#line 39 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 39 "../src/Device.vala"
	result = self->priv->_is_muted;
#line 39 "../src/Device.vala"
	return result;
#line 729 "Device.c"
}

void
sound_device_set_is_muted (SoundDevice* self,
                           gboolean value)
{
#line 39 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/Device.vala"
	if (sound_device_get_is_muted (self) != value) {
#line 39 "../src/Device.vala"
		self->priv->_is_muted = value;
#line 39 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_IS_MUTED_PROPERTY]);
#line 744 "Device.c"
	}
}

void
sound_device_get_cvolume (SoundDevice* self,
                          pa_cvolume * result)
{
	pa_cvolume _tmp0_;
#line 40 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/Device.vala"
	_tmp0_ = self->priv->_cvolume;
#line 40 "../src/Device.vala"
	*result = _tmp0_;
#line 40 "../src/Device.vala"
	return;
#line 761 "Device.c"
}

void
sound_device_set_cvolume (SoundDevice* self,
                          pa_cvolume * value)
{
	pa_cvolume _tmp0_;
#line 40 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/Device.vala"
	_tmp0_ = *value;
#line 40 "../src/Device.vala"
	self->priv->_cvolume = _tmp0_;
#line 775 "Device.c"
}

gdouble
sound_device_get_volume (SoundDevice* self)
{
	gdouble result;
#line 41 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 41 "../src/Device.vala"
	result = self->priv->_volume;
#line 41 "../src/Device.vala"
	return result;
#line 788 "Device.c"
}

void
sound_device_set_volume (SoundDevice* self,
                         gdouble value)
{
#line 41 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 41 "../src/Device.vala"
	if (sound_device_get_volume (self) != value) {
#line 41 "../src/Device.vala"
		self->priv->_volume = value;
#line 41 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_VOLUME_PROPERTY]);
#line 803 "Device.c"
	}
}

gfloat
sound_device_get_balance (SoundDevice* self)
{
	gfloat result;
#line 42 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, 0.0F);
#line 42 "../src/Device.vala"
	result = self->priv->_balance;
#line 42 "../src/Device.vala"
	return result;
#line 817 "Device.c"
}

void
sound_device_set_balance (SoundDevice* self,
                          gfloat value)
{
#line 42 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/Device.vala"
	if (sound_device_get_balance (self) != value) {
#line 42 "../src/Device.vala"
		self->priv->_balance = value;
#line 42 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_BALANCE_PROPERTY]);
#line 832 "Device.c"
	}
}

void
sound_device_get_channel_map (SoundDevice* self,
                              pa_channel_map * result)
{
	pa_channel_map _tmp0_;
#line 43 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/Device.vala"
	_tmp0_ = self->priv->_channel_map;
#line 43 "../src/Device.vala"
	*result = _tmp0_;
#line 43 "../src/Device.vala"
	return;
#line 849 "Device.c"
}

void
sound_device_set_channel_map (SoundDevice* self,
                              pa_channel_map * value)
{
	pa_channel_map _tmp0_;
#line 43 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/Device.vala"
	_tmp0_ = *value;
#line 43 "../src/Device.vala"
	self->priv->_channel_map = _tmp0_;
#line 863 "Device.c"
}

GeeArrayList*
sound_device_get_ports (SoundDevice* self)
{
	GeeArrayList* result;
	GeeArrayList* _tmp0_;
#line 45 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 45 "../src/Device.vala"
	_tmp0_ = self->priv->_ports;
#line 45 "../src/Device.vala"
	result = _tmp0_;
#line 45 "../src/Device.vala"
	return result;
#line 879 "Device.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 45 "../src/Device.vala"
	return self ? g_object_ref (self) : NULL;
#line 887 "Device.c"
}

void
sound_device_set_ports (SoundDevice* self,
                        GeeArrayList* value)
{
#line 45 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/Device.vala"
	if (sound_device_get_ports (self) != value) {
#line 898 "Device.c"
		GeeArrayList* _tmp0_;
#line 45 "../src/Device.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 45 "../src/Device.vala"
		_g_object_unref0 (self->priv->_ports);
#line 45 "../src/Device.vala"
		self->priv->_ports = _tmp0_;
#line 45 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_PORTS_PROPERTY]);
#line 908 "Device.c"
	}
}

SoundDevicePort*
sound_device_get_default_port (SoundDevice* self)
{
	SoundDevicePort* result;
	SoundDevicePort* _tmp0_;
#line 46 "../src/Device.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../src/Device.vala"
	_tmp0_ = self->priv->_default_port;
#line 46 "../src/Device.vala"
	result = _tmp0_;
#line 46 "../src/Device.vala"
	return result;
#line 925 "Device.c"
}

static gpointer
_sound_device_port_ref0 (gpointer self)
{
#line 46 "../src/Device.vala"
	return self ? sound_device_port_ref (self) : NULL;
#line 933 "Device.c"
}

void
sound_device_set_default_port (SoundDevice* self,
                               SoundDevicePort* value)
{
#line 46 "../src/Device.vala"
	g_return_if_fail (self != NULL);
#line 46 "../src/Device.vala"
	if (sound_device_get_default_port (self) != value) {
#line 944 "Device.c"
		SoundDevicePort* _tmp0_;
#line 46 "../src/Device.vala"
		_tmp0_ = _sound_device_port_ref0 (value);
#line 46 "../src/Device.vala"
		_sound_device_port_unref0 (self->priv->_default_port);
#line 46 "../src/Device.vala"
		self->priv->_default_port = _tmp0_;
#line 46 "../src/Device.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_properties[SOUND_DEVICE_DEFAULT_PORT_PROPERTY]);
#line 954 "Device.c"
	}
}

static GObject *
sound_device_constructor (GType type,
                          guint n_construct_properties,
                          GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundDevice * self;
	GeeLinkedList* _tmp0_;
	GeeArrayList* _tmp1_;
	GeeArrayList* _tmp2_;
#line 52 "../src/Device.vala"
	parent_class = G_OBJECT_CLASS (sound_device_parent_class);
#line 52 "../src/Device.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 52 "../src/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_DEVICE, SoundDevice);
#line 53 "../src/Device.vala"
	_tmp0_ = gee_linked_list_new (G_TYPE_POINTER, (GBoxedCopyFunc) pa_operation_ref, (GDestroyNotify) pa_operation_unref, NULL, NULL, NULL);
#line 53 "../src/Device.vala"
	_g_object_unref0 (self->volume_operations);
#line 53 "../src/Device.vala"
	self->volume_operations = _tmp0_;
#line 54 "../src/Device.vala"
	_tmp1_ = gee_array_list_new (SOUND_DEVICE_TYPE_PORT, (GBoxedCopyFunc) sound_device_port_ref, (GDestroyNotify) sound_device_port_unref, NULL, NULL, NULL);
#line 54 "../src/Device.vala"
	_tmp2_ = _tmp1_;
#line 54 "../src/Device.vala"
	sound_device_set_ports (self, _tmp2_);
#line 54 "../src/Device.vala"
	_g_object_unref0 (_tmp2_);
#line 52 "../src/Device.vala"
	return obj;
#line 991 "Device.c"
}

SoundDevicePort*
sound_device_port_construct (GType object_type)
{
	SoundDevicePort* self = NULL;
#line 25 "../src/Device.vala"
	self = (SoundDevicePort*) g_type_create_instance (object_type);
#line 25 "../src/Device.vala"
	return self;
#line 1002 "Device.c"
}

SoundDevicePort*
sound_device_port_new (void)
{
#line 25 "../src/Device.vala"
	return sound_device_port_construct (SOUND_DEVICE_TYPE_PORT);
#line 1010 "Device.c"
}

static void
sound_device_value_port_init (GValue* value)
{
#line 25 "../src/Device.vala"
	value->data[0].v_pointer = NULL;
#line 1018 "Device.c"
}

static void
sound_device_value_port_free_value (GValue* value)
{
#line 25 "../src/Device.vala"
	if (value->data[0].v_pointer) {
#line 25 "../src/Device.vala"
		sound_device_port_unref (value->data[0].v_pointer);
#line 1028 "Device.c"
	}
}

static void
sound_device_value_port_copy_value (const GValue* src_value,
                                    GValue* dest_value)
{
#line 25 "../src/Device.vala"
	if (src_value->data[0].v_pointer) {
#line 25 "../src/Device.vala"
		dest_value->data[0].v_pointer = sound_device_port_ref (src_value->data[0].v_pointer);
#line 1040 "Device.c"
	} else {
#line 25 "../src/Device.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1044 "Device.c"
	}
}

static gpointer
sound_device_value_port_peek_pointer (const GValue* value)
{
#line 25 "../src/Device.vala"
	return value->data[0].v_pointer;
#line 1053 "Device.c"
}

static gchar*
sound_device_value_port_collect_value (GValue* value,
                                       guint n_collect_values,
                                       GTypeCValue* collect_values,
                                       guint collect_flags)
{
#line 25 "../src/Device.vala"
	if (collect_values[0].v_pointer) {
#line 1064 "Device.c"
		SoundDevicePort * object;
		object = collect_values[0].v_pointer;
#line 25 "../src/Device.vala"
		if (object->parent_instance.g_class == NULL) {
#line 25 "../src/Device.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1071 "Device.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 25 "../src/Device.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1075 "Device.c"
		}
#line 25 "../src/Device.vala"
		value->data[0].v_pointer = sound_device_port_ref (object);
#line 1079 "Device.c"
	} else {
#line 25 "../src/Device.vala"
		value->data[0].v_pointer = NULL;
#line 1083 "Device.c"
	}
#line 25 "../src/Device.vala"
	return NULL;
#line 1087 "Device.c"
}

static gchar*
sound_device_value_port_lcopy_value (const GValue* value,
                                     guint n_collect_values,
                                     GTypeCValue* collect_values,
                                     guint collect_flags)
{
	SoundDevicePort ** object_p;
	object_p = collect_values[0].v_pointer;
#line 25 "../src/Device.vala"
	if (!object_p) {
#line 25 "../src/Device.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1102 "Device.c"
	}
#line 25 "../src/Device.vala"
	if (!value->data[0].v_pointer) {
#line 25 "../src/Device.vala"
		*object_p = NULL;
#line 1108 "Device.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 25 "../src/Device.vala"
		*object_p = value->data[0].v_pointer;
#line 1112 "Device.c"
	} else {
#line 25 "../src/Device.vala"
		*object_p = sound_device_port_ref (value->data[0].v_pointer);
#line 1116 "Device.c"
	}
#line 25 "../src/Device.vala"
	return NULL;
#line 1120 "Device.c"
}

GParamSpec*
sound_device_param_spec_port (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags)
{
	SoundDeviceParamSpecPort* spec;
#line 25 "../src/Device.vala"
	g_return_val_if_fail (g_type_is_a (object_type, SOUND_DEVICE_TYPE_PORT), NULL);
#line 25 "../src/Device.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 25 "../src/Device.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 25 "../src/Device.vala"
	return G_PARAM_SPEC (spec);
#line 1139 "Device.c"
}

gpointer
sound_device_value_get_port (const GValue* value)
{
#line 25 "../src/Device.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SOUND_DEVICE_TYPE_PORT), NULL);
#line 25 "../src/Device.vala"
	return value->data[0].v_pointer;
#line 1149 "Device.c"
}

void
sound_device_value_set_port (GValue* value,
                             gpointer v_object)
{
	SoundDevicePort * old;
#line 25 "../src/Device.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SOUND_DEVICE_TYPE_PORT));
#line 25 "../src/Device.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/Device.vala"
	if (v_object) {
#line 25 "../src/Device.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SOUND_DEVICE_TYPE_PORT));
#line 25 "../src/Device.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/Device.vala"
		value->data[0].v_pointer = v_object;
#line 25 "../src/Device.vala"
		sound_device_port_ref (value->data[0].v_pointer);
#line 1171 "Device.c"
	} else {
#line 25 "../src/Device.vala"
		value->data[0].v_pointer = NULL;
#line 1175 "Device.c"
	}
#line 25 "../src/Device.vala"
	if (old) {
#line 25 "../src/Device.vala"
		sound_device_port_unref (old);
#line 1181 "Device.c"
	}
}

void
sound_device_value_take_port (GValue* value,
                              gpointer v_object)
{
	SoundDevicePort * old;
#line 25 "../src/Device.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, SOUND_DEVICE_TYPE_PORT));
#line 25 "../src/Device.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/Device.vala"
	if (v_object) {
#line 25 "../src/Device.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, SOUND_DEVICE_TYPE_PORT));
#line 25 "../src/Device.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/Device.vala"
		value->data[0].v_pointer = v_object;
#line 1202 "Device.c"
	} else {
#line 25 "../src/Device.vala"
		value->data[0].v_pointer = NULL;
#line 1206 "Device.c"
	}
#line 25 "../src/Device.vala"
	if (old) {
#line 25 "../src/Device.vala"
		sound_device_port_unref (old);
#line 1212 "Device.c"
	}
}

static void
sound_device_port_class_init (SoundDevicePortClass * klass,
                              gpointer klass_data)
{
#line 25 "../src/Device.vala"
	sound_device_port_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/Device.vala"
	((SoundDevicePortClass *) klass)->finalize = sound_device_port_finalize;
#line 1224 "Device.c"
}

static void
sound_device_port_instance_init (SoundDevicePort * self,
                                 gpointer klass)
{
#line 25 "../src/Device.vala"
	self->ref_count = 1;
#line 1233 "Device.c"
}

static void
sound_device_port_finalize (SoundDevicePort * obj)
{
	SoundDevicePort * self;
#line 25 "../src/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_DEVICE_TYPE_PORT, SoundDevicePort);
#line 25 "../src/Device.vala"
	g_signal_handlers_destroy (self);
#line 26 "../src/Device.vala"
	_g_free0 (self->name);
#line 27 "../src/Device.vala"
	_g_free0 (self->description);
#line 1248 "Device.c"
}

GType
sound_device_port_get_type (void)
{
	static volatile gsize sound_device_port_type_id__volatile = 0;
	if (g_once_init_enter (&sound_device_port_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { sound_device_value_port_init, sound_device_value_port_free_value, sound_device_value_port_copy_value, sound_device_value_port_peek_pointer, "p", sound_device_value_port_collect_value, "p", sound_device_value_port_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (SoundDevicePortClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_device_port_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundDevicePort), 0, (GInstanceInitFunc) sound_device_port_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType sound_device_port_type_id;
		sound_device_port_type_id = g_type_register_fundamental (g_type_fundamental_next (), "SoundDevicePort", &g_define_type_info, &g_define_type_fundamental_info, 0);
		g_once_init_leave (&sound_device_port_type_id__volatile, sound_device_port_type_id);
	}
	return sound_device_port_type_id__volatile;
}

gpointer
sound_device_port_ref (gpointer instance)
{
	SoundDevicePort * self;
	self = instance;
#line 25 "../src/Device.vala"
	g_atomic_int_inc (&self->ref_count);
#line 25 "../src/Device.vala"
	return instance;
#line 1275 "Device.c"
}

void
sound_device_port_unref (gpointer instance)
{
	SoundDevicePort * self;
	self = instance;
#line 25 "../src/Device.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 25 "../src/Device.vala"
		SOUND_DEVICE_PORT_GET_CLASS (self)->finalize (self);
#line 25 "../src/Device.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1289 "Device.c"
	}
}

static void
sound_device_class_init (SoundDeviceClass * klass,
                         gpointer klass_data)
{
#line 24 "../src/Device.vala"
	sound_device_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Device.vala"
	g_type_class_adjust_private_offset (klass, &SoundDevice_private_offset);
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_device_get_property;
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_device_set_property;
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_device_constructor;
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_device_finalize;
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_INPUT_PROPERTY, sound_device_properties[SOUND_DEVICE_INPUT_PROPERTY] = g_param_spec_boolean ("input", "input", "input", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_INDEX_PROPERTY, sound_device_properties[SOUND_DEVICE_INDEX_PROPERTY] = g_param_spec_uint ("index", "index", "index", 0, G_MAXUINT, (guint32) 0U, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_DISPLAY_NAME_PROPERTY, sound_device_properties[SOUND_DEVICE_DISPLAY_NAME_PROPERTY] = g_param_spec_string ("display-name", "display-name", "display-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_FORM_FACTOR_PROPERTY, sound_device_properties[SOUND_DEVICE_FORM_FACTOR_PROPERTY] = g_param_spec_string ("form-factor", "form-factor", "form-factor", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_IS_DEFAULT_PROPERTY, sound_device_properties[SOUND_DEVICE_IS_DEFAULT_PROPERTY] = g_param_spec_boolean ("is-default", "is-default", "is-default", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_IS_MUTED_PROPERTY, sound_device_properties[SOUND_DEVICE_IS_MUTED_PROPERTY] = g_param_spec_boolean ("is-muted", "is-muted", "is-muted", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_VOLUME_PROPERTY, sound_device_properties[SOUND_DEVICE_VOLUME_PROPERTY] = g_param_spec_double ("volume", "volume", "volume", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_BALANCE_PROPERTY, sound_device_properties[SOUND_DEVICE_BALANCE_PROPERTY] = g_param_spec_float ("balance", "balance", "balance", -G_MAXFLOAT, G_MAXFLOAT, (gfloat) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_PORTS_PROPERTY, sound_device_properties[SOUND_DEVICE_PORTS_PROPERTY] = g_param_spec_object ("ports", "ports", "ports", GEE_TYPE_ARRAY_LIST, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_DEFAULT_PORT_PROPERTY, sound_device_properties[SOUND_DEVICE_DEFAULT_PORT_PROPERTY] = sound_device_param_spec_port ("default-port", "default-port", "default-port", SOUND_DEVICE_TYPE_PORT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/Device.vala"
	sound_device_signals[SOUND_DEVICE_REMOVED_SIGNAL] = g_signal_new ("removed", SOUND_TYPE_DEVICE, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 1333 "Device.c"
}

static void
sound_device_instance_init (SoundDevice * self,
                            gpointer klass)
{
#line 24 "../src/Device.vala"
	self->priv = sound_device_get_instance_private (self);
#line 33 "../src/Device.vala"
	self->priv->_input = TRUE;
#line 34 "../src/Device.vala"
	self->priv->_index = (guint32) 0U;
#line 38 "../src/Device.vala"
	self->priv->_is_default = FALSE;
#line 39 "../src/Device.vala"
	self->priv->_is_muted = FALSE;
#line 41 "../src/Device.vala"
	self->priv->_volume = (gdouble) 0;
#line 42 "../src/Device.vala"
	self->priv->_balance = (gfloat) 0;
#line 46 "../src/Device.vala"
	self->priv->_default_port = NULL;
#line 1356 "Device.c"
}

static void
sound_device_finalize (GObject * obj)
{
	SoundDevice * self;
#line 24 "../src/Device.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_DEVICE, SoundDevice);
#line 35 "../src/Device.vala"
	_g_free0 (self->priv->_name);
#line 36 "../src/Device.vala"
	_g_free0 (self->priv->_display_name);
#line 37 "../src/Device.vala"
	_g_free0 (self->priv->_form_factor);
#line 44 "../src/Device.vala"
	_g_object_unref0 (self->volume_operations);
#line 45 "../src/Device.vala"
	_g_object_unref0 (self->priv->_ports);
#line 46 "../src/Device.vala"
	_sound_device_port_unref0 (self->priv->_default_port);
#line 24 "../src/Device.vala"
	G_OBJECT_CLASS (sound_device_parent_class)->finalize (obj);
#line 1379 "Device.c"
}

GType
sound_device_get_type (void)
{
	static volatile gsize sound_device_type_id__volatile = 0;
	if (g_once_init_enter (&sound_device_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SoundDeviceClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_device_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundDevice), 0, (GInstanceInitFunc) sound_device_instance_init, NULL };
		GType sound_device_type_id;
		sound_device_type_id = g_type_register_static (G_TYPE_OBJECT, "SoundDevice", &g_define_type_info, 0);
		SoundDevice_private_offset = g_type_add_instance_private (sound_device_type_id, sizeof (SoundDevicePrivate));
		g_once_init_leave (&sound_device_type_id__volatile, sound_device_type_id);
	}
	return sound_device_type_id__volatile;
}

static void
_vala_sound_device_get_property (GObject * object,
                                 guint property_id,
                                 GValue * value,
                                 GParamSpec * pspec)
{
	SoundDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_DEVICE, SoundDevice);
#line 24 "../src/Device.vala"
	switch (property_id) {
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_INPUT_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_boolean (value, sound_device_get_input (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_uint (value, sound_device_get_index (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_DISPLAY_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_display_name (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_FORM_FACTOR_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_string (value, sound_device_get_form_factor (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_IS_DEFAULT_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_boolean (value, sound_device_get_is_default (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_IS_MUTED_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_boolean (value, sound_device_get_is_muted (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_VOLUME_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_double (value, sound_device_get_volume (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_BALANCE_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_float (value, sound_device_get_balance (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_PORTS_PROPERTY:
#line 24 "../src/Device.vala"
		g_value_set_object (value, sound_device_get_ports (self));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_DEFAULT_PORT_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_value_set_port (value, sound_device_get_default_port (self));
#line 24 "../src/Device.vala"
		break;
#line 1472 "Device.c"
		default:
#line 24 "../src/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Device.vala"
		break;
#line 1478 "Device.c"
	}
}

static void
_vala_sound_device_set_property (GObject * object,
                                 guint property_id,
                                 const GValue * value,
                                 GParamSpec * pspec)
{
	SoundDevice * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_DEVICE, SoundDevice);
#line 24 "../src/Device.vala"
	switch (property_id) {
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_INPUT_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_input (self, g_value_get_boolean (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_INDEX_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_index (self, g_value_get_uint (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_DISPLAY_NAME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_display_name (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_FORM_FACTOR_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_form_factor (self, g_value_get_string (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_IS_DEFAULT_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_is_default (self, g_value_get_boolean (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_IS_MUTED_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_is_muted (self, g_value_get_boolean (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_VOLUME_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_volume (self, g_value_get_double (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_BALANCE_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_balance (self, g_value_get_float (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_PORTS_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_ports (self, g_value_get_object (value));
#line 24 "../src/Device.vala"
		break;
#line 24 "../src/Device.vala"
		case SOUND_DEVICE_DEFAULT_PORT_PROPERTY:
#line 24 "../src/Device.vala"
		sound_device_set_default_port (self, sound_device_value_get_port (value));
#line 24 "../src/Device.vala"
		break;
#line 1558 "Device.c"
		default:
#line 24 "../src/Device.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/Device.vala"
		break;
#line 1564 "Device.c"
	}
}

