/* DeviceRow.c generated by valac 0.43.4, the Vala compiler
 * generated from DeviceRow.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016-2017 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include <gtk/gtk.h>
#include <glib-object.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>

#define SOUND_TYPE_DEVICE_ROW (sound_device_row_get_type ())
#define SOUND_DEVICE_ROW(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_DEVICE_ROW, SoundDeviceRow))
#define SOUND_DEVICE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_DEVICE_ROW, SoundDeviceRowClass))
#define SOUND_IS_DEVICE_ROW(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_DEVICE_ROW))
#define SOUND_IS_DEVICE_ROW_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_DEVICE_ROW))
#define SOUND_DEVICE_ROW_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_DEVICE_ROW, SoundDeviceRowClass))

typedef struct _SoundDeviceRow SoundDeviceRow;
typedef struct _SoundDeviceRowClass SoundDeviceRowClass;
typedef struct _SoundDeviceRowPrivate SoundDeviceRowPrivate;

#define SOUND_TYPE_DEVICE (sound_device_get_type ())
#define SOUND_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), SOUND_TYPE_DEVICE, SoundDevice))
#define SOUND_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), SOUND_TYPE_DEVICE, SoundDeviceClass))
#define SOUND_IS_DEVICE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), SOUND_TYPE_DEVICE))
#define SOUND_IS_DEVICE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), SOUND_TYPE_DEVICE))
#define SOUND_DEVICE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), SOUND_TYPE_DEVICE, SoundDeviceClass))

typedef struct _SoundDevice SoundDevice;
typedef struct _SoundDeviceClass SoundDeviceClass;
enum  {
	SOUND_DEVICE_ROW_0_PROPERTY,
	SOUND_DEVICE_ROW_DEVICE_PROPERTY,
	SOUND_DEVICE_ROW_NUM_PROPERTIES
};
static GParamSpec* sound_device_row_properties[SOUND_DEVICE_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	SOUND_DEVICE_ROW_SET_AS_DEFAULT_SIGNAL,
	SOUND_DEVICE_ROW_NUM_SIGNALS
};
static guint sound_device_row_signals[SOUND_DEVICE_ROW_NUM_SIGNALS] = {0};

struct _SoundDeviceRow {
	GtkListBoxRow parent_instance;
	SoundDeviceRowPrivate * priv;
};

struct _SoundDeviceRowClass {
	GtkListBoxRowClass parent_class;
};

struct _SoundDeviceRowPrivate {
	SoundDevice* _device;
	GtkLabel* name_label;
	GtkLabel* description_label;
	GtkRadioButton* activate_radio;
	gboolean ignore_default;
};

static gint SoundDeviceRow_private_offset;
static gpointer sound_device_row_parent_class = NULL;

GType sound_device_row_get_type (void) G_GNUC_CONST;
GType sound_device_get_type (void) G_GNUC_CONST;
SoundDeviceRow* sound_device_row_new (SoundDevice* device);
SoundDeviceRow* sound_device_row_construct (GType object_type,
                                            SoundDevice* device);
void sound_device_row_link_to_row (SoundDeviceRow* self,
                                   SoundDeviceRow* row);
SoundDevice* sound_device_row_get_device (SoundDeviceRow* self);
gboolean sound_device_get_is_default (SoundDevice* self);
static void sound_device_row_set_device (SoundDeviceRow* self,
                                  SoundDevice* value);
static GObject * sound_device_row_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
const gchar* sound_device_get_display_name (SoundDevice* self);
gchar* sound_device_get_nice_form_factor (SoundDevice* self);
static void _sound_device_row___lambda9_ (SoundDeviceRow* self);
static void __sound_device_row___lambda9__gtk_list_box_row_activate (GtkListBoxRow* _sender,
                                                              gpointer self);
static void _sound_device_row___lambda10_ (SoundDeviceRow* self);
static void __sound_device_row___lambda10__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                               gpointer self);
static void _sound_device_row___lambda11_ (SoundDeviceRow* self);
static void __sound_device_row___lambda11__sound_device_removed (SoundDevice* _sender,
                                                          gpointer self);
static void _sound_device_row___lambda12_ (SoundDeviceRow* self);
static void __sound_device_row___lambda12__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void _sound_device_row___lambda13_ (SoundDeviceRow* self);
static void __sound_device_row___lambda13__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self);
static void sound_device_row_finalize (GObject * obj);
static void _vala_sound_device_row_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_sound_device_row_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);

static inline gpointer
sound_device_row_get_instance_private (SoundDeviceRow* self)
{
	return G_STRUCT_MEMBER_P (self, SoundDeviceRow_private_offset);
}

SoundDeviceRow*
sound_device_row_construct (GType object_type,
                            SoundDevice* device)
{
	SoundDeviceRow * self = NULL;
#line 31 "../src/DeviceRow.vala"
	g_return_val_if_fail (device != NULL, NULL);
#line 32 "../src/DeviceRow.vala"
	self = (SoundDeviceRow*) g_object_new (object_type, "device", device, NULL);
#line 31 "../src/DeviceRow.vala"
	return self;
#line 149 "DeviceRow.c"
}

SoundDeviceRow*
sound_device_row_new (SoundDevice* device)
{
#line 31 "../src/DeviceRow.vala"
	return sound_device_row_construct (SOUND_TYPE_DEVICE_ROW, device);
#line 157 "DeviceRow.c"
}

void
sound_device_row_link_to_row (SoundDeviceRow* self,
                              SoundDeviceRow* row)
{
	GtkRadioButton* _tmp0_;
	GtkRadioButton* _tmp1_;
	GtkRadioButton* _tmp2_;
	SoundDevice* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
#line 35 "../src/DeviceRow.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/DeviceRow.vala"
	g_return_if_fail (row != NULL);
#line 36 "../src/DeviceRow.vala"
	_tmp0_ = self->priv->activate_radio;
#line 36 "../src/DeviceRow.vala"
	_tmp1_ = row->priv->activate_radio;
#line 36 "../src/DeviceRow.vala"
	gtk_radio_button_join_group (_tmp0_, _tmp1_);
#line 37 "../src/DeviceRow.vala"
	_tmp2_ = self->priv->activate_radio;
#line 37 "../src/DeviceRow.vala"
	_tmp3_ = self->priv->_device;
#line 37 "../src/DeviceRow.vala"
	_tmp4_ = sound_device_get_is_default (_tmp3_);
#line 37 "../src/DeviceRow.vala"
	_tmp5_ = _tmp4_;
#line 37 "../src/DeviceRow.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp2_, _tmp5_);
#line 190 "DeviceRow.c"
}

SoundDevice*
sound_device_row_get_device (SoundDeviceRow* self)
{
	SoundDevice* result;
	SoundDevice* _tmp0_;
#line 26 "../src/DeviceRow.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/DeviceRow.vala"
	_tmp0_ = self->priv->_device;
#line 26 "../src/DeviceRow.vala"
	result = _tmp0_;
#line 26 "../src/DeviceRow.vala"
	return result;
#line 206 "DeviceRow.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 26 "../src/DeviceRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 214 "DeviceRow.c"
}

static void
sound_device_row_set_device (SoundDeviceRow* self,
                             SoundDevice* value)
{
#line 26 "../src/DeviceRow.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/DeviceRow.vala"
	if (sound_device_row_get_device (self) != value) {
#line 225 "DeviceRow.c"
		SoundDevice* _tmp0_;
#line 26 "../src/DeviceRow.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 26 "../src/DeviceRow.vala"
		_g_object_unref0 (self->priv->_device);
#line 26 "../src/DeviceRow.vala"
		self->priv->_device = _tmp0_;
#line 26 "../src/DeviceRow.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_device_row_properties[SOUND_DEVICE_ROW_DEVICE_PROPERTY]);
#line 235 "DeviceRow.c"
	}
}

static void
_sound_device_row___lambda9_ (SoundDeviceRow* self)
{
	GtkRadioButton* _tmp0_;
#line 56 "../src/DeviceRow.vala"
	_tmp0_ = self->priv->activate_radio;
#line 56 "../src/DeviceRow.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, TRUE);
#line 247 "DeviceRow.c"
}

static void
__sound_device_row___lambda9__gtk_list_box_row_activate (GtkListBoxRow* _sender,
                                                         gpointer self)
{
#line 56 "../src/DeviceRow.vala"
	_sound_device_row___lambda9_ ((SoundDeviceRow*) self);
#line 256 "DeviceRow.c"
}

static void
_sound_device_row___lambda10_ (SoundDeviceRow* self)
{
	gboolean _tmp0_ = FALSE;
	GtkRadioButton* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 58 "../src/DeviceRow.vala"
	_tmp1_ = self->priv->activate_radio;
#line 58 "../src/DeviceRow.vala"
	_tmp2_ = gtk_toggle_button_get_active ((GtkToggleButton*) _tmp1_);
#line 58 "../src/DeviceRow.vala"
	_tmp3_ = _tmp2_;
#line 58 "../src/DeviceRow.vala"
	if (_tmp3_) {
#line 58 "../src/DeviceRow.vala"
		_tmp0_ = !self->priv->ignore_default;
#line 276 "DeviceRow.c"
	} else {
#line 58 "../src/DeviceRow.vala"
		_tmp0_ = FALSE;
#line 280 "DeviceRow.c"
	}
#line 58 "../src/DeviceRow.vala"
	if (_tmp0_) {
#line 59 "../src/DeviceRow.vala"
		g_signal_emit (self, sound_device_row_signals[SOUND_DEVICE_ROW_SET_AS_DEFAULT_SIGNAL], 0);
#line 286 "DeviceRow.c"
	}
}

static void
__sound_device_row___lambda10__gtk_toggle_button_toggled (GtkToggleButton* _sender,
                                                          gpointer self)
{
#line 57 "../src/DeviceRow.vala"
	_sound_device_row___lambda10_ ((SoundDeviceRow*) self);
#line 296 "DeviceRow.c"
}

static void
_sound_device_row___lambda11_ (SoundDeviceRow* self)
{
#line 65 "../src/DeviceRow.vala"
	gtk_widget_destroy ((GtkWidget*) self);
#line 304 "DeviceRow.c"
}

static void
__sound_device_row___lambda11__sound_device_removed (SoundDevice* _sender,
                                                     gpointer self)
{
#line 65 "../src/DeviceRow.vala"
	_sound_device_row___lambda11_ ((SoundDeviceRow*) self);
#line 313 "DeviceRow.c"
}

static void
_sound_device_row___lambda12_ (SoundDeviceRow* self)
{
	GtkRadioButton* _tmp0_;
	SoundDevice* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 67 "../src/DeviceRow.vala"
	self->priv->ignore_default = TRUE;
#line 68 "../src/DeviceRow.vala"
	_tmp0_ = self->priv->activate_radio;
#line 68 "../src/DeviceRow.vala"
	_tmp1_ = self->priv->_device;
#line 68 "../src/DeviceRow.vala"
	_tmp2_ = sound_device_get_is_default (_tmp1_);
#line 68 "../src/DeviceRow.vala"
	_tmp3_ = _tmp2_;
#line 68 "../src/DeviceRow.vala"
	gtk_toggle_button_set_active ((GtkToggleButton*) _tmp0_, _tmp3_);
#line 69 "../src/DeviceRow.vala"
	self->priv->ignore_default = FALSE;
#line 337 "DeviceRow.c"
}

static void
__sound_device_row___lambda12__g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 66 "../src/DeviceRow.vala"
	_sound_device_row___lambda12_ ((SoundDeviceRow*) self);
#line 347 "DeviceRow.c"
}

static void
_sound_device_row___lambda13_ (SoundDeviceRow* self)
{
	GtkLabel* _tmp0_;
	SoundDevice* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 73 "../src/DeviceRow.vala"
	_tmp0_ = self->priv->description_label;
#line 73 "../src/DeviceRow.vala"
	_tmp1_ = self->priv->_device;
#line 73 "../src/DeviceRow.vala"
	_tmp2_ = sound_device_get_nice_form_factor (_tmp1_);
#line 73 "../src/DeviceRow.vala"
	_tmp3_ = _tmp2_;
#line 73 "../src/DeviceRow.vala"
	gtk_label_set_label (_tmp0_, _tmp3_);
#line 73 "../src/DeviceRow.vala"
	_g_free0 (_tmp3_);
#line 369 "DeviceRow.c"
}

static void
__sound_device_row___lambda13__g_object_notify (GObject* _sender,
                                                GParamSpec* pspec,
                                                gpointer self)
{
#line 72 "../src/DeviceRow.vala"
	_sound_device_row___lambda13_ ((SoundDeviceRow*) self);
#line 379 "DeviceRow.c"
}

static GObject *
sound_device_row_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundDeviceRow * self;
	GtkGrid* grid = NULL;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
	GtkGrid* _tmp2_;
	GtkGrid* _tmp3_;
	SoundDevice* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GtkLabel* _tmp7_;
	GtkLabel* _tmp8_;
	GtkLabel* _tmp9_;
	SoundDevice* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GtkLabel* _tmp13_;
	GtkLabel* _tmp14_;
	GtkLabel* _tmp15_;
	GtkStyleContext* _tmp16_;
	GtkRadioButton* _tmp17_;
	GtkGrid* _tmp18_;
	GtkRadioButton* _tmp19_;
	GtkGrid* _tmp20_;
	GtkLabel* _tmp21_;
	GtkGrid* _tmp22_;
	GtkLabel* _tmp23_;
	GtkGrid* _tmp24_;
	GtkRadioButton* _tmp25_;
	SoundDevice* _tmp26_;
	GtkLabel* _tmp27_;
	SoundDevice* _tmp28_;
	SoundDevice* _tmp29_;
	SoundDevice* _tmp30_;
#line 40 "../src/DeviceRow.vala"
	parent_class = G_OBJECT_CLASS (sound_device_row_parent_class);
#line 40 "../src/DeviceRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 40 "../src/DeviceRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_DEVICE_ROW, SoundDeviceRow);
#line 41 "../src/DeviceRow.vala"
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
#line 41 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp0_);
#line 41 "../src/DeviceRow.vala"
	grid = _tmp0_;
#line 42 "../src/DeviceRow.vala"
	_tmp1_ = grid;
#line 42 "../src/DeviceRow.vala"
	g_object_set ((GtkWidget*) _tmp1_, "margin", 6, NULL);
#line 43 "../src/DeviceRow.vala"
	_tmp2_ = grid;
#line 43 "../src/DeviceRow.vala"
	gtk_grid_set_column_spacing (_tmp2_, 12);
#line 44 "../src/DeviceRow.vala"
	_tmp3_ = grid;
#line 44 "../src/DeviceRow.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp3_, GTK_ORIENTATION_HORIZONTAL);
#line 45 "../src/DeviceRow.vala"
	_tmp4_ = self->priv->_device;
#line 45 "../src/DeviceRow.vala"
	_tmp5_ = sound_device_get_display_name (_tmp4_);
#line 45 "../src/DeviceRow.vala"
	_tmp6_ = _tmp5_;
#line 45 "../src/DeviceRow.vala"
	_tmp7_ = (GtkLabel*) gtk_label_new (_tmp6_);
#line 45 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp7_);
#line 45 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->name_label);
#line 45 "../src/DeviceRow.vala"
	self->priv->name_label = _tmp7_;
#line 46 "../src/DeviceRow.vala"
	_tmp8_ = self->priv->name_label;
#line 46 "../src/DeviceRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp8_, TRUE);
#line 47 "../src/DeviceRow.vala"
	_tmp9_ = self->priv->name_label;
#line 47 "../src/DeviceRow.vala"
	gtk_label_set_xalign (_tmp9_, (gfloat) 0);
#line 48 "../src/DeviceRow.vala"
	_tmp10_ = self->priv->_device;
#line 48 "../src/DeviceRow.vala"
	_tmp11_ = sound_device_get_nice_form_factor (_tmp10_);
#line 48 "../src/DeviceRow.vala"
	_tmp12_ = _tmp11_;
#line 48 "../src/DeviceRow.vala"
	_tmp13_ = (GtkLabel*) gtk_label_new (_tmp12_);
#line 48 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp13_);
#line 48 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->description_label);
#line 48 "../src/DeviceRow.vala"
	self->priv->description_label = _tmp13_;
#line 48 "../src/DeviceRow.vala"
	_g_free0 (_tmp12_);
#line 49 "../src/DeviceRow.vala"
	_tmp14_ = self->priv->description_label;
#line 49 "../src/DeviceRow.vala"
	gtk_widget_set_halign ((GtkWidget*) _tmp14_, GTK_ALIGN_END);
#line 50 "../src/DeviceRow.vala"
	_tmp15_ = self->priv->description_label;
#line 50 "../src/DeviceRow.vala"
	_tmp16_ = gtk_widget_get_style_context ((GtkWidget*) _tmp15_);
#line 50 "../src/DeviceRow.vala"
	gtk_style_context_add_class (_tmp16_, GTK_STYLE_CLASS_DIM_LABEL);
#line 51 "../src/DeviceRow.vala"
	_tmp17_ = (GtkRadioButton*) gtk_radio_button_new (NULL);
#line 51 "../src/DeviceRow.vala"
	g_object_ref_sink (_tmp17_);
#line 51 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->activate_radio);
#line 51 "../src/DeviceRow.vala"
	self->priv->activate_radio = _tmp17_;
#line 52 "../src/DeviceRow.vala"
	_tmp18_ = grid;
#line 52 "../src/DeviceRow.vala"
	_tmp19_ = self->priv->activate_radio;
#line 52 "../src/DeviceRow.vala"
	gtk_container_add ((GtkContainer*) _tmp18_, (GtkWidget*) _tmp19_);
#line 53 "../src/DeviceRow.vala"
	_tmp20_ = grid;
#line 53 "../src/DeviceRow.vala"
	_tmp21_ = self->priv->name_label;
#line 53 "../src/DeviceRow.vala"
	gtk_container_add ((GtkContainer*) _tmp20_, (GtkWidget*) _tmp21_);
#line 54 "../src/DeviceRow.vala"
	_tmp22_ = grid;
#line 54 "../src/DeviceRow.vala"
	_tmp23_ = self->priv->description_label;
#line 54 "../src/DeviceRow.vala"
	gtk_container_add ((GtkContainer*) _tmp22_, (GtkWidget*) _tmp23_);
#line 55 "../src/DeviceRow.vala"
	_tmp24_ = grid;
#line 55 "../src/DeviceRow.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp24_);
#line 56 "../src/DeviceRow.vala"
	g_signal_connect_object ((GtkListBoxRow*) self, "activate", (GCallback) __sound_device_row___lambda9__gtk_list_box_row_activate, self, 0);
#line 57 "../src/DeviceRow.vala"
	_tmp25_ = self->priv->activate_radio;
#line 57 "../src/DeviceRow.vala"
	g_signal_connect_object ((GtkToggleButton*) _tmp25_, "toggled", (GCallback) __sound_device_row___lambda10__gtk_toggle_button_toggled, self, 0);
#line 63 "../src/DeviceRow.vala"
	_tmp26_ = self->priv->_device;
#line 63 "../src/DeviceRow.vala"
	_tmp27_ = self->priv->name_label;
#line 63 "../src/DeviceRow.vala"
	g_object_bind_property_with_closures ((GObject*) _tmp26_, "display-name", (GObject*) _tmp27_, "label", G_BINDING_DEFAULT, (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)), (GClosure*) ((NULL == NULL) ? NULL : g_cclosure_new ((GCallback) NULL, NULL, (GClosureNotify) NULL)));
#line 65 "../src/DeviceRow.vala"
	_tmp28_ = self->priv->_device;
#line 65 "../src/DeviceRow.vala"
	g_signal_connect_object (_tmp28_, "removed", (GCallback) __sound_device_row___lambda11__sound_device_removed, self, 0);
#line 66 "../src/DeviceRow.vala"
	_tmp29_ = self->priv->_device;
#line 66 "../src/DeviceRow.vala"
	g_signal_connect_object ((GObject*) _tmp29_, "notify::is-default", (GCallback) __sound_device_row___lambda12__g_object_notify, self, 0);
#line 72 "../src/DeviceRow.vala"
	_tmp30_ = self->priv->_device;
#line 72 "../src/DeviceRow.vala"
	g_signal_connect_object ((GObject*) _tmp30_, "notify::form-factor", (GCallback) __sound_device_row___lambda13__g_object_notify, self, 0);
#line 40 "../src/DeviceRow.vala"
	_g_object_unref0 (grid);
#line 40 "../src/DeviceRow.vala"
	return obj;
#line 552 "DeviceRow.c"
}

static void
sound_device_row_class_init (SoundDeviceRowClass * klass,
                             gpointer klass_data)
{
#line 23 "../src/DeviceRow.vala"
	sound_device_row_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/DeviceRow.vala"
	g_type_class_adjust_private_offset (klass, &SoundDeviceRow_private_offset);
#line 23 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_device_row_get_property;
#line 23 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_device_row_set_property;
#line 23 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_device_row_constructor;
#line 23 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_device_row_finalize;
#line 23 "../src/DeviceRow.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_DEVICE_ROW_DEVICE_PROPERTY, sound_device_row_properties[SOUND_DEVICE_ROW_DEVICE_PROPERTY] = g_param_spec_object ("device", "device", "device", SOUND_TYPE_DEVICE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 23 "../src/DeviceRow.vala"
	sound_device_row_signals[SOUND_DEVICE_ROW_SET_AS_DEFAULT_SIGNAL] = g_signal_new ("set-as-default", SOUND_TYPE_DEVICE_ROW, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 575 "DeviceRow.c"
}

static void
sound_device_row_instance_init (SoundDeviceRow * self,
                                gpointer klass)
{
#line 23 "../src/DeviceRow.vala"
	self->priv = sound_device_row_get_instance_private (self);
#line 30 "../src/DeviceRow.vala"
	self->priv->ignore_default = FALSE;
#line 586 "DeviceRow.c"
}

static void
sound_device_row_finalize (GObject * obj)
{
	SoundDeviceRow * self;
#line 23 "../src/DeviceRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_DEVICE_ROW, SoundDeviceRow);
#line 26 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->_device);
#line 27 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->name_label);
#line 28 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->description_label);
#line 29 "../src/DeviceRow.vala"
	_g_object_unref0 (self->priv->activate_radio);
#line 23 "../src/DeviceRow.vala"
	G_OBJECT_CLASS (sound_device_row_parent_class)->finalize (obj);
#line 605 "DeviceRow.c"
}

GType
sound_device_row_get_type (void)
{
	static volatile gsize sound_device_row_type_id__volatile = 0;
	if (g_once_init_enter (&sound_device_row_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (SoundDeviceRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_device_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundDeviceRow), 0, (GInstanceInitFunc) sound_device_row_instance_init, NULL };
		GType sound_device_row_type_id;
		sound_device_row_type_id = g_type_register_static (gtk_list_box_row_get_type (), "SoundDeviceRow", &g_define_type_info, 0);
		SoundDeviceRow_private_offset = g_type_add_instance_private (sound_device_row_type_id, sizeof (SoundDeviceRowPrivate));
		g_once_init_leave (&sound_device_row_type_id__volatile, sound_device_row_type_id);
	}
	return sound_device_row_type_id__volatile;
}

static void
_vala_sound_device_row_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	SoundDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_DEVICE_ROW, SoundDeviceRow);
#line 23 "../src/DeviceRow.vala"
	switch (property_id) {
#line 23 "../src/DeviceRow.vala"
		case SOUND_DEVICE_ROW_DEVICE_PROPERTY:
#line 23 "../src/DeviceRow.vala"
		g_value_set_object (value, sound_device_row_get_device (self));
#line 23 "../src/DeviceRow.vala"
		break;
#line 638 "DeviceRow.c"
		default:
#line 23 "../src/DeviceRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/DeviceRow.vala"
		break;
#line 644 "DeviceRow.c"
	}
}

static void
_vala_sound_device_row_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	SoundDeviceRow * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TYPE_DEVICE_ROW, SoundDeviceRow);
#line 23 "../src/DeviceRow.vala"
	switch (property_id) {
#line 23 "../src/DeviceRow.vala"
		case SOUND_DEVICE_ROW_DEVICE_PROPERTY:
#line 23 "../src/DeviceRow.vala"
		sound_device_row_set_device (self, g_value_get_object (value));
#line 23 "../src/DeviceRow.vala"
		break;
#line 664 "DeviceRow.c"
		default:
#line 23 "../src/DeviceRow.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 23 "../src/DeviceRow.vala"
		break;
#line 670 "DeviceRow.c"
	}
}

